/** 此脚本升级采购合同条款分录，销售合同条款分录，采购付款计划分录数据 */

/** ============= 采购合同条款，tableName改变，数据升级 ============== */
/** 升级组件数据 */
DELETE FROM T_CONM_PURCONTRACTTENTRY WHERE FENTRYID IN (
    SELECT DISTINCT C2.FENTRYID
    FROM T_CONM_TERMCOMP C1 
    INNER JOIN T_CONM_TERMCOMPENTRY C2 ON C1.FID = C2.FID 
    INNER JOIN T_CONM_PURCONTRACT C3
    ON C2.FID = C3.FID 
    WHERE C3.FID = C1.FCONTRACTID);
IF EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CONM_PURCONTRACTTENTRY')
INSERT INTO T_CONM_PURCONTRACTTENTRY(FID, FENTRYID, FSEQ, FTERMGROUPID, FTERMID, FTERMENTRYCHANGETYPE) 
    SELECT DISTINCT C1.FCONTRACTID, C2.FENTRYID, C2.FSEQ,  C2.FTERMGROUPID,  C2.FTERMID, FTERMENTRYCHANGETYPE
    FROM T_CONM_TERMCOMP C1 
    INNER JOIN T_CONM_TERMCOMPENTRY C2 ON C1.FID = C2.FID 
    INNER JOIN T_CONM_PURCONTRACT C3
    ON C2.FID = C3.FID 
    WHERE C3.FID = C1.FCONTRACTID; 

-- 升级组件多语言
DELETE FROM T_CONM_PURCONTRACTTENTRY_L WHERE FPKID IN (
    SELECT DISTINCT C4.FPKID
    FROM T_CONM_TERMCOMP C1 INNER JOIN T_CONM_TERMCOMPENTRY C2 ON C1.FID = C2.FID 
    INNER JOIN T_CONM_PURCONTRACT C3 ON C2.FID = C3.FID 
    INNER JOIN T_CONM_TERMCOMPENTRY_L C4 ON C2.FENTRYID = C4.FENTRYID
    WHERE C3.FID = C1.FCONTRACTID
);
IF EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CONM_PURCONTRACTTENTRY_L') 
INSERT INTO T_CONM_PURCONTRACTTENTRY_L(FPKID, FENTRYID, FLOCALEID, FTERMCONTENT) 
    SELECT DISTINCT C4.FPKID, C2.FENTRYID, C4.FLOCALEID, C4.FTERMCONTENT
    FROM T_CONM_TERMCOMP C1 INNER JOIN T_CONM_TERMCOMPENTRY C2 ON C1.FID = C2.FID 
    INNER JOIN T_CONM_PURCONTRACT C3 ON C2.FID = C3.FID 
    INNER JOIN T_CONM_TERMCOMPENTRY_L C4 ON C2.FENTRYID = C4.FENTRYID
    WHERE C3.FID = C1.FCONTRACTID;


/** 升级移除组件之后的数据 */
DELETE FROM T_CONM_PURCONTRACTTENTRY WHERE FENTRYID IN(
    SELECT FENTRYID
    FROM T_CONM_TERMCOMPENTRY C1 INNER JOIN T_CONM_PURCONTRACT C2 ON C1.FID = C2.FID
    -- 排除组件数据
    WHERE C1.FID NOT IN( SELECT C3.FCONTRACTID
    FROM T_CONM_TERMCOMP C3 INNER JOIN T_CONM_TERMCOMPENTRY C4 ON C3.FID = C4.FID INNER JOIN T_CONM_PURCONTRACT C5
    ON C4.FID = C5.FID WHERE C2.FID = C3.FCONTRACTID)
);
IF EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CONM_PURCONTRACTTENTRY') 
INSERT INTO T_CONM_PURCONTRACTTENTRY(FID, FENTRYID, FSEQ, FTERMGROUPID, FTERMID, FTERMENTRYCHANGETYPE)
    SELECT C2.FID, FENTRYID, FSEQ, FTERMGROUPID, FTERMID, FTERMENTRYCHANGETYPE 
    FROM T_CONM_TERMCOMPENTRY C1 INNER JOIN T_CONM_PURCONTRACT C2 ON C1.FID = C2.FID
    -- 排除组件数据
    WHERE C1.FID NOT IN( SELECT C3.FCONTRACTID
    FROM T_CONM_TERMCOMP C3 INNER JOIN T_CONM_TERMCOMPENTRY C4 ON C3.FID = C4.FID INNER JOIN T_CONM_PURCONTRACT C5
    ON C4.FID = C5.FID WHERE C2.FID = C3.FCONTRACTID);

-- 升级多语言
DELETE FROM T_CONM_PURCONTRACTTENTRY_L WHERE FPKID IN(
    SELECT C2.FPKID
    FROM T_CONM_TERMCOMPENTRY C1 INNER JOIN T_CONM_TERMCOMPENTRY_L C2 ON C1.FENTRYID = C2.FENTRYID
    INNER JOIN T_CONM_PURCONTRACT C3 ON C1.FID = C3.FID
     -- 排除组件数据
    WHERE C1.FID NOT IN( SELECT C4.FCONTRACTID
    FROM T_CONM_TERMCOMP C4 INNER JOIN T_CONM_TERMCOMPENTRY C5 ON C4.FID = C5.FID INNER JOIN T_CONM_PURCONTRACT C6
    ON C5.FID = C6.FID WHERE C3.FID = C4.FCONTRACTID)
);
IF EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CONM_PURCONTRACTTENTRY_L') 
INSERT INTO T_CONM_PURCONTRACTTENTRY_L(FPKID, FENTRYID, FLOCALEID, FTERMCONTENT) 
    SELECT C2.FPKID, C1.FENTRYID, C2.FLOCALEID, C2.FTERMCONTENT
    FROM T_CONM_TERMCOMPENTRY C1 INNER JOIN T_CONM_TERMCOMPENTRY_L C2 ON C1.FENTRYID = C2.FENTRYID
    INNER JOIN T_CONM_PURCONTRACT C3 ON C1.FID = C3.FID
     -- 排除组件数据
    WHERE C1.FID NOT IN( SELECT C4.FCONTRACTID
    FROM T_CONM_TERMCOMP C4 INNER JOIN T_CONM_TERMCOMPENTRY C5 ON C4.FID = C5.FID INNER JOIN T_CONM_PURCONTRACT C6
    ON C5.FID = C6.FID WHERE C3.FID = C4.FCONTRACTID);


/** ============= 采购付款计划，tableName改变，数据升级 ============== */
DELETE FROM T_CONM_PURCONTRACTPENTRY WHERE FENTRYID IN ( 
    SELECT FENTRYID FROM T_CONM_PURCONTRACT T1 INNER JOIN T_CONM_CONTRACTPENTRY T2 ON T1.FID = T2.FID);
IF EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CONM_PURCONTRACTPENTRY') 
INSERT INTO T_CONM_PURCONTRACTPENTRY(FENTRYID, FID, FSEQ, FPAYNAMEID, FPAYDATE, FPAYRATE, FPAYAMOUNT, FISPREPAY, FJOINPAYAMOUNT, FPAIDAMOUNT, FPAYENTRYCHANGETYPE) 
    SELECT FENTRYID, T2.FID, FSEQ, FPAYNAMEID, FPAYDATE, FPAYRATE, FPAYAMOUNT, FISPREPAY, FJOINPAYAMOUNT, FPAIDAMOUNT, FPAYENTRYCHANGETYPE 
    FROM T_CONM_PURCONTRACT T1 INNER JOIN T_CONM_CONTRACTPENTRY T2 ON T1.FID = T2.FID;



/** ============= 销售合同条款，tableName改变，数据升级 ============== */
-- 升级组件
DELETE FROM T_CONM_SALCONTRACTTENTRY WHERE FENTRYID IN(
    SELECT DISTINCT C2.FENTRYID
    FROM T_CONM_TERMCOMP C1 
    INNER JOIN T_CONM_TERMCOMPENTRY C2 ON C1.FID = C2.FID 
    INNER JOIN T_CONM_SALCONTRACT C3
    ON C2.FID = C3.FID 
    WHERE C3.FID = C1.FCONTRACTID
);
IF EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CONM_SALCONTRACTTENTRY')
INSERT INTO T_CONM_SALCONTRACTTENTRY(FID, FENTRYID, FSEQ, FTERMGROUPID, FTERMID, FTERMENTRYCHANGETYPE) 
    SELECT DISTINCT C1.FCONTRACTID, C2.FENTRYID, C2.FSEQ,  C2.FTERMGROUPID,  C2.FTERMID, FTERMENTRYCHANGETYPE
    FROM T_CONM_TERMCOMP C1 
    INNER JOIN T_CONM_TERMCOMPENTRY C2 ON C1.FID = C2.FID 
    INNER JOIN T_CONM_SALCONTRACT C3
    ON C2.FID = C3.FID 
    WHERE C3.FID = C1.FCONTRACTID; 

-- 升级多语言
DELETE FROM T_CONM_SALCONTRACTTENTRY_L WHERE FPKID IN(
    SELECT DISTINCT C4.FPKID
    FROM T_CONM_TERMCOMP C1 INNER JOIN T_CONM_TERMCOMPENTRY C2 ON C1.FID = C2.FID 
    INNER JOIN T_CONM_SALCONTRACT C3 ON C2.FID = C3.FID 
    INNER JOIN T_CONM_TERMCOMPENTRY_L C4 ON C2.FENTRYID = C4.FENTRYID
    WHERE C1.FCONTRACTID =C3.FID
);
IF EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CONM_SALCONTRACTTENTRY_L') 
INSERT INTO T_CONM_SALCONTRACTTENTRY_L(FPKID, FENTRYID, FLOCALEID, FTERMCONTENT) 
    SELECT DISTINCT C4.FPKID, C2.FENTRYID, C4.FLOCALEID, C4.FTERMCONTENT
    FROM T_CONM_TERMCOMP C1 INNER JOIN T_CONM_TERMCOMPENTRY C2 ON C1.FID = C2.FID 
    INNER JOIN T_CONM_SALCONTRACT C3 ON C2.FID = C3.FID 
    INNER JOIN T_CONM_TERMCOMPENTRY_L C4 ON C2.FENTRYID = C4.FENTRYID
    WHERE C1.FCONTRACTID =C3.FID;

-- 升级移除组件之后的数据
DELETE FROM T_CONM_SALCONTRACTTENTRY WHERE FENTRYID IN(
    SELECT FENTRYID
    FROM T_CONM_TERMCOMPENTRY C1 INNER JOIN T_CONM_SALCONTRACT C2 ON C1.FID = C2.FID
    -- 排除组件数据
    WHERE C1.FID NOT IN( SELECT C3.FCONTRACTID
    FROM T_CONM_TERMCOMP C3 INNER JOIN T_CONM_TERMCOMPENTRY C4 ON C3.FID = C4.FID INNER JOIN T_CONM_SALCONTRACT C5
    ON C4.FID = C5.FID WHERE C3.FCONTRACTID = C5.FID)
);
IF EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CONM_SALCONTRACTTENTRY') 
INSERT INTO T_CONM_SALCONTRACTTENTRY(FID, FENTRYID, FSEQ, FTERMGROUPID, FTERMID, FTERMENTRYCHANGETYPE)
    SELECT C2.FID, FENTRYID, FSEQ, FTERMGROUPID, FTERMID, FTERMENTRYCHANGETYPE 
    FROM T_CONM_TERMCOMPENTRY C1 INNER JOIN T_CONM_SALCONTRACT C2 ON C1.FID = C2.FID
    -- 排除组件数据
    WHERE C1.FID NOT IN( SELECT C3.FCONTRACTID
    FROM T_CONM_TERMCOMP C3 INNER JOIN T_CONM_TERMCOMPENTRY C4 ON C3.FID = C4.FID INNER JOIN T_CONM_SALCONTRACT C5
    ON C4.FID = C5.FID WHERE C3.FCONTRACTID = C5.FID);
-- 升级多语言
DELETE FROM T_CONM_SALCONTRACTTENTRY_L WHERE FPKID IN(
     SELECT C2.FPKID
    FROM T_CONM_TERMCOMPENTRY C1 INNER JOIN T_CONM_TERMCOMPENTRY_L C2 ON C1.FENTRYID = C2.FENTRYID
    INNER JOIN T_CONM_SALCONTRACT C3 ON C1.FID = C3.FID
     -- 排除组件数据
    WHERE C1.FID NOT IN( SELECT C4.FCONTRACTID
    FROM T_CONM_TERMCOMP C4 INNER JOIN T_CONM_TERMCOMPENTRY C5 ON C4.FID = C5.FID INNER JOIN T_CONM_SALCONTRACT C6
    ON C5.FID = C6.FID WHERE C4.FCONTRACTID = C3.FID)
);
IF EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CONM_SALCONTRACTTENTRY_L') 
INSERT INTO T_CONM_SALCONTRACTTENTRY_L(FPKID, FENTRYID, FLOCALEID, FTERMCONTENT) 
    SELECT C2.FPKID, C1.FENTRYID, C2.FLOCALEID, C2.FTERMCONTENT
    FROM T_CONM_TERMCOMPENTRY C1 INNER JOIN T_CONM_TERMCOMPENTRY_L C2 ON C1.FENTRYID = C2.FENTRYID
    INNER JOIN T_CONM_SALCONTRACT C3 ON C1.FID = C3.FID
     -- 排除组件数据
    WHERE C1.FID NOT IN( SELECT C4.FCONTRACTID
    FROM T_CONM_TERMCOMP C4 INNER JOIN T_CONM_TERMCOMPENTRY C5 ON C4.FID = C5.FID INNER JOIN T_CONM_SALCONTRACT C6
    ON C5.FID = C6.FID WHERE C4.FCONTRACTID = C3.FID);